prepare-release 7.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195
  1. #!/bin/sh
  2. set -e
  3. cd "$(readlink -f $(dirname $0))"
  4. if [ -n "${GBP_BUILD_DIR}" ]; then
  5. cd "$GBP_BUILD_DIR"
  6. fi
  7. VERSION=$(dpkg-parsechangelog | sed -n -e '/^Version:/s/^Version: //p')
  8. DISTRIBUTION=$(dpkg-parsechangelog | sed -n -e '/^Distribution:/s/^Distribution: //p')
  9. LIBAPTPKGVERSION="$(awk -v ORS='.' '/^\#define APT_PKG_M/ {print $3}' apt-pkg/contrib/macros.h | sed 's/\.$//')"
  10. LIBAPTINSTVERSION="$(grep '^MAJOR=' apt-inst/makefile |cut -d '=' -f 2)"
  11. librarysymbolsfromfile() {
  12. local MISSING="$(grep '^+#MISSING' "$1")"
  13. local SYMVER="$2"
  14. echo '=== Missing optional symbols:'
  15. echo -n "$MISSING" | grep '|optional=' || true
  16. echo '=== Missing required symbols:'
  17. echo -n "$MISSING" | grep -v '|optional=' || true
  18. echo '=== New symbols:'
  19. grep '^+ ' "$1" | cut -d' ' -f 2 | cut -d'@' -f 1 | c++filt | while read line; do
  20. echo " (c++)\"${line}@${SYMVER}\" $VERSION"
  21. done | sort -u
  22. }
  23. if [ "$1" = 'pre-export' ]; then
  24. libraryversioncheck() {
  25. local LIBRARY="$1"
  26. local VERSION="$2"
  27. if [ ! -e "debian/${LIBRARY}${VERSION}.symbols" ]; then
  28. echo >&2 "Library ${LIBRARY} in version ${VERSION} has no symbols file! (maybe forgot to rename?)"
  29. exit 1
  30. fi
  31. if [ "$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")" != "${LIBRARY}.so.${VERSION} ${LIBRARY}${VERSION} #MINVER#" ]; then
  32. echo >&2 "Library ${LIBRARY}${VERSION} has incorrect version in symbol header! (»$(head -n1 "debian/${LIBRARY}${VERSION}.symbols")«)"
  33. exit 2
  34. fi
  35. }
  36. libraryversioncheck 'libapt-pkg' "$LIBAPTPKGVERSION"
  37. libraryversioncheck 'libapt-inst' "$LIBAPTINSTVERSION"
  38. if [ "$DISTRIBUTION" = 'sid' ]; then
  39. echo >&2 '»sid« is not a valid distribution. Replace it with »unstable« for you'
  40. sed -i -e 's/) sid; urgency=/) unstable; urgency=/' debian/changelog
  41. DISTRIBUTION='unstable'
  42. elif [ "$DISTRIBUTION" = 'UNRELEASED' ]; then
  43. echo >&2 'WARNING: Remember to change to a valid distribution for release'
  44. VERSION="$VERSION~$(date +%Y%m%d)"
  45. fi
  46. sed -i -e "s/^PACKAGE_VERSION=\".*\"$/PACKAGE_VERSION=\"${VERSION}\"/" configure.ac
  47. sed -i -e "s/^<!ENTITY apt-product-version \".*\">$/<!ENTITY apt-product-version \"${VERSION}\">/" doc/apt-verbatim.ent
  48. # update the last-modification field of manpages based on git changes
  49. grep --files-with-matches '<date>' doc/*.xml | while read file; do \
  50. LASTMOD="$(date -d "@$(git log --format='%at' --max-count=1 --invert-grep --fixed-strings --grep 'review
  51. typo
  52. Git-Dch: Ignore' "$file")" '+%Y-%m-%dT00:00:00Z')"
  53. sed -i -e "s#^\([ ]\+\)<date>.*</date>\$#\1<date>$LASTMOD</date>#" "$file"
  54. done
  55. if [ "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' po/apt-all.pot | cut -d' ' -f 2)" -o \
  56. "$(date +%Y-%m-%d)" != "$(grep --max-count=1 '^"POT-Creation-Date: .*\n"$' doc/po/apt-doc.pot | cut -d' ' -f 2)" ]; then
  57. echo >&2 'POT files are not up-to-date. Execute »make update-po« for you…'
  58. make update-po
  59. fi
  60. elif [ "$1" = 'post-build' ]; then
  61. if [ "$DISTRIBUTION" != "UNRELEASED" ]; then
  62. echo >&2 "REMEMBER: Tag this release with »git tag -s ${VERSION}« if you are satisfied"
  63. else
  64. echo >&2 'REMEMBER: Change to a valid distribution before release'
  65. fi
  66. dpkg-checkbuilddeps -d 'libxml2-utils'
  67. HEADERBLUEPRINT="$(mktemp)"
  68. sed -n '1,/^$/p' doc/apt.8.xml > "$HEADERBLUEPRINT"
  69. find doc -mindepth 1 -maxdepth 1 -type f -name '*.xml' | while read FILE; do
  70. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  71. echo >&2 "WARNING: Manpage $FILE has not the usual header! (see diff below)"
  72. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  73. fi
  74. done
  75. sed -n '1,/^$/p' doc/guide.dbk > "$HEADERBLUEPRINT"
  76. find doc -mindepth 1 -maxdepth 1 -type f -name '*.dbk' | while read FILE; do
  77. if ! sed -n '1,/^$/p' "$FILE" | cmp "$HEADERBLUEPRINT" - >/dev/null 2>&1; then
  78. echo >&2 "WARNING: Documentation $FILE has not the usual header (see diff below)!"
  79. sed -n '1,/^$/p' "$FILE" | diff -u "$HEADERBLUEPRINT" - || true
  80. fi
  81. done
  82. rm "$HEADERBLUEPRINT"
  83. # check the manpages with each vendor for vendor-specific errors…
  84. find vendor -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 2 | while read DISTRO; do
  85. ln -sf ../vendor/${DISTRO}/apt-vendor.ent doc
  86. if ! xmllint --nonet --valid --noout $(find doc/ -maxdepth 1 -name '*.xml'); then
  87. echo >&2 "WARNING: original docbook manpages have errors with vendor ${DISTRO}!"
  88. fi
  89. done
  90. # lets assume we will always have a german manpage translation
  91. if [ -e 'doc/de/' ]; then
  92. # … but check the translations only with one vendor for translation-specific errors
  93. if ! xmllint --nonet --valid --noout $(find doc/ -mindepth 2 -maxdepth 2 -name '*.xml'); then
  94. echo >&2 "WARNING: translated docbook manpages have errors!"
  95. fi
  96. else
  97. echo >&2 "ERROR: translated manpages need to be build before they can be checked!"
  98. fi
  99. rm -f doc/apt-vendor.ent
  100. elif [ "$1" = 'library' ]; then
  101. librarysymbols() {
  102. echo "Checking $1 in version $2"
  103. local tmpfile=$(mktemp)
  104. dpkg-gensymbols -p${1}${2} -ebuild/bin/${1}.so.${2} -Idebian/${1}${2}.symbols -O/dev/null 2> /dev/null > $tmpfile || true
  105. librarysymbolsfromfile "$tmpfile" "$(echo "${1}" | cut -c 4- | tr -d '-' | tr 'a-z' 'A-Z')_${2}"
  106. rm -f $tmpfile
  107. }
  108. librarysymbols 'libapt-pkg' "${LIBAPTPKGVERSION}"
  109. echo
  110. librarysymbols 'libapt-inst' "${LIBAPTINSTVERSION}"
  111. elif [ "$1" = 'buildlog' ]; then
  112. while [ -n "$2" ]; do
  113. librarysymbolsfromfile "$2" 'UNKNOWN'
  114. shift
  115. done
  116. elif [ "$1" = 'travis-ci' ]; then
  117. apt-get install -qy --no-install-recommends $(sed -n -e '/^Build-Depends: /,/^Build-Depends-Indep: / {p}' debian/control | sed -e 's#([^)]*)##g' -e 's#^Build-Depends\(-Indep\)\?: ##' | tr -d ',')
  118. apt-get install -qy --no-install-recommends $(sed -n 's#^Depends: .*@, \(.*\)$#\1#p' debian/tests/control | tr -d ',')
  119. elif [ "$1" = 'coverage' ]; then
  120. DIR="${2:-./coverage}"
  121. git clean -dfX # remove ignored build artefacts for a clean start
  122. make CFLAGS+='--coverage' CXXFLAGS+='--coverage'
  123. LCOVRC='--rc geninfo_checksum=1 --rc lcov_branch_coverage=1'
  124. mkdir "$DIR"
  125. lcov --no-external --directory . --capture --initial --output-file "${DIR}/apt.coverage.init" ${LCOVRC}
  126. make test || true
  127. ./test/integration/run-tests -q || true
  128. lcov --no-external --directory . --capture --output-file "${DIR}/apt.coverage.run" ${LCOVRC}
  129. lcov -a "${DIR}/apt.coverage.init" -a "${DIR}/apt.coverage.run" -o "${DIR}/apt.coverage.total" ${LCOVRC}
  130. cp "${DIR}/apt.coverage.total" "${DIR}/apt.coverage.fixed"
  131. rewritefile() {
  132. file="$1"
  133. shift
  134. name="$(basename "$file")"
  135. while [ -n "$1" ]; do
  136. if [ -r "$1/$name" ]; then
  137. sed -i "s#$file#$1/$name#" "${DIR}/apt.coverage.fixed"
  138. break
  139. fi
  140. shift
  141. done
  142. if [ -z "$1" ]; then
  143. echo >&2 "Coverage data captured for unknown file $file"
  144. fi
  145. }
  146. grep 'build/include/' "${DIR}/apt.coverage.fixed" | sed "s#^SF:$(pwd)/##" | while read file; do
  147. rewritefile "$file" 'apt-pkg' 'apt-pkg/deb' 'apt-pkg/edsp' 'apt-pkg/contrib' \
  148. 'apt-inst' 'apt-inst/deb' 'apt-inst/contrib' 'apt-private'
  149. done
  150. genhtml --output-directory "${DIR}" "${DIR}/apt.coverage.fixed" ${LCOVRC}
  151. else
  152. echo >&1 "Usage:\t$0 pre-export
  153. \t$0 post-build
  154. If you use »gbp buildpackage« you can leave these alone as they will
  155. be run at the right places auto-magically. Otherwise you should use
  156. »pre-export« to update po and pot files as well as version numbering.
  157. »post-build« can be used to run some more or less useful checks later on.
  158. \t$0 library
  159. \t$0 buildlog filename…
  160. »library« and »buildlog« aren't run automatically but can be useful for
  161. maintaining the (more or less experimental) symbols files we provide.
  162. »library« displays the diff between advertised symbols and the once provided
  163. by the libraries, while »buildlog« extracts this diff from the buildlogs.
  164. Both will format the diff properly.
  165. \t$0 travis-ci
  166. \t$0 coverage [output-dir]
  167. »travis-ci« is a shortcut to install all build- as well as test-dependencies
  168. used by .travis.yml.
  169. »coverage« does a clean build with the right flags for coverage reporting,
  170. runs all tests and generates a html report in the end.
  171. "
  172. fi